$compile unit

$error all-
$lib all-

defint a-z




SUB SYSINFO (PrinterPorts, SerialPorts, GamePort, FloppyDrives, VideoMode, MathCo) PUBLIC

CALL INTERRUPT &H11
AH? = REG(1) \ 256
AL? = REG(1) AND &HFF
IF (AH? AND &B01000000) = &B01000000 THEN PrinterPorts = 1
IF (AH? AND &B10000000) = &B10000000 THEN PrinterPorts = 2
IF (AH? AND &B11000000) = &B11000000 THEN PrinterPorts = 3

IF (AH? AND &B0010) = &B0010 THEN SerialPorts = 1
IF (AH? AND &B0100) = &B0100 THEN SerialPorts = 2
IF (AH? AND &B0110) = &B0110 THEN SerialPorts = 3
IF (AH? AND &B1000) = &B1000 THEN SerialPorts = 4

IF Bit(AH?,4) THEN GamePort = 0

IF (AL? AND &B00000001) = &B00000001 THEN FloppyDrives = 1
IF (AL? AND &B01000001) = &B01000001 THEN FloppyDrives = 2
IF (AL? AND &B10000001) = &B10000001 THEN FloppyDrives = 3
IF (AL? AND &B11000001) = &B11000001 THEN FloppyDrives = 4

IF (AL? AND &B010000) = &B010000 THEN VideoMode = 1  ' 40x25 color
IF (AL? AND &B100000) = &B100000 THEN VideoMode = 2  ' 80x25 color
IF (AL? AND &B110000) = &B110000 THEN VideoMode = 3  ' 80x25 mono

IF Bit(AL?,1) THEN MathCo = 1

END SUB



SUB SerialAddr(Com1$, Com2$, Com3$, Com4$)  PUBLIC
LOCAL P$(),A$,A


DIM P$(4)
' Set segment
DEF SEG = &H40
' read comm addresses
A$=PEEK$(0,8)
' restore segment
DEF SEG
' get comm port addresses

FOR A=1 TO 7 STEP 2
P$((A+1)\2) = HEX$(ASC(MID$(A$,A+1,1)))+HEX$(ASC(MID$(A$,A,1)))
NEXT A

' AVAILABLE PORTS

IF P$(1) = "00" THEN Com1$ = "N/A" ELSE Com1$ = P$(1)
IF P$(2) = "00" THEN Com2$ = "N/A" ELSE Com2$ = P$(2)
IF P$(3) = "00" THEN Com3$ = "N/A" ELSE Com3$ = P$(3)
IF P$(4) = "00" THEN Com4$ = "N/A" ELSE Com4$ = P$(4)

END SUB


SUB ParallelAddr(Lpt1$, Lpt2$, Lpt3$)  PUBLIC
LOCAL P$(),A$,A

DIM P$(3)
' Set segment
DEF SEG = &H40
' read port addresses
A$=PEEK$(8,6)
' restore segment
DEF SEG

' get printer port port addresses
FOR A=1 TO 5 STEP 2
P$((A+1)\2) = HEX$(ASC(MID$(A$,A+1,1)))+HEX$(ASC(MID$(A$,A,1)))
NEXT A

' AVAILABLE PORTS

IF P$(1) = "00" THEN Lpt1$ = "N/A" ELSE Lpt1$ = P$(1)
IF P$(2) = "00" THEN Lpt2$ = "N/A" ELSE Lpt2$ = P$(2)
IF P$(3) = "00" THEN Lpt3$ = "N/A" ELSE Lpt3$ = P$(3)

END SUB



SUB MemSize(KB)  PUBLIC

CALL INTERRUPT &H12
KB=REG(1)
END SUB



SUB GetVideoMode(Mode,Page)  PUBLIC
REG 1, &H0F00
CALL INTERRUPT &H10
Mode = REG(1) AND &HFF
'00h = 40x26/16 text (color burst off)
'01h = 40x25/16 text
'02h = 80x25/16 text (color burst off)
'03h = 80x25/16 text
'04h = 320x200/4 Graphics
'05h = 320x200/4 Graphics (color burst off)
'06h = 640x200/2 Graphics
'07h = 80x25 Monochrome text
'08h = 160x200/16 Graphics
'09h = 320x200/16 Graphics
'0Ah = 640x200/4 Graphics
'0Bh = reserved
'0Ch = reserved
'0Dh = 320x200/16 Graphics
'0Eh = 640x200/16 Graphics
'0Fh = 640x350 Monochrome Graphics
'10h = 640x350/16 Graphics
'11h = 640x480/2 Graphics
'12h = 640z480/16 Graphics
'13h = 320x200/256 Graphics
Page = REG(2) \ 256
END SUB



SUB MouseInfo(There,Buttons)  PUBLIC

REG 1,0
CALL INTERRUPT &H33
There = REG(1)
Buttons = REG(2)
END SUB




SUB EMSXMSInfo(EMM,EMSFree,XMM,XMSFree)  PUBLIC

IF ATTRIB("EMMXXXX0")=64 THEN
	REG 1,&H4200	'get number of EMM pages
		CALL INTERRUPT &H67
		EMM = REG(4) * 16
		EMSFree = REG(2) * 16
END IF

REG 1,&H4300  ' detect XMS
CALL INTERRUPT &H2F
IF (REG(1) AND &HFF) = &H80 THEN  ' XMS present
	REG 1, &H0800   ' get number of XMS KB
	CALL INTERRUPT &H2F
		XMSFree = REG(4)
		XMM = -1
END IF

END SUB




